<template>
  <div class="app-container">

    <div class="search">
      <el-date-picker v-model="table.getdataListParm.parammaps.inputDatetime" class="inputDatetime filter-item" type="daterange" :range-separator="$t('common.to')"  :start-placeholder="$t('common.startTime')" :end-placeholder="$t('common.endTime')" style="width: 250px;" />
      <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
      <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
      <el-select v-model="table.getdataListParm.parammaps.cowclassid" :placeholder="$t('feedingEfficiency.cxlb')" class="filter-item" style="width: 150px;" clearable>
        <el-option v-for="item in livestockTypeList" :key="item.value" :label="item.label" :value="item.value" />
      </el-select>
      <el-select v-model="table.getdataListParm.parammaps.feedid":placeholder="$t('InventoryManagement.silc')"    class="filter-item" style="width: 150px;" filterable clearable>
        <el-option v-for="item in feedNameList" :key="item.id" :label="item.fname" :value="item.id" />
      </el-select>
      <el-select v-model="table.getdataListParm.parammaps.ischarge" placeholder="是否审核" class="filter-item" style="width: 150px;" clearable>
        <el-option v-for="item in isAuditList" :key="item.id" :label="item.name" :value="item.id" />
      </el-select>
      <el-button class="successBorder" @click="form_search">{{$t('common.query')}}</el-button>
      <el-button class="successBorder" @click="handleRefresh">{{$t('common.reset')}}</el-button>
    </div>
    <div class="operation">
      <el-button v-if="isRoleEdit" class="success" icon="el-icon-document-checked" @click="handleExamine">审核</el-button>
      <el-button class="export" icon="el-icon-upload2" style="float: right;margin-right: 10px;" @click="handleExport">{{$t('formulationEvaluation.out')}}</el-button>
    </div>
    <div class="table">
      <el-table
        :key="table.tableKey"
        v-loading="table.listLoading"
        :element-loading-text="$t('common.tableMsg')"
        :data="table.list"
        border
        fit
        highlight-current-row
        style="width: 100%;"
        :row-style="rowStyle"
        :cell-style="cellStyle"
        class="elTable table-fixed"
        @selection-change="handleSelectionChange"
      >
        <el-table-column type="selection" align="center" width="50" />
        <el-table-column :label="$t('formulationEvaluation.xh')" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="业务日期" min-width="100px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.usedate }}</span>
          </template>
        </el-table-column>
        <el-table-column :label="$t('errorAnalysis.sxlb')" min-width="100px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.cowclass }}</span>
          </template>
        </el-table-column>
        <el-table-column :label="$t('InventoryManagement.silc')"    min-width="100px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.feedname }}</span>
          </template>
        </el-table-column>
        <el-table-column label="是否预混料" min-width="100px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.feedname }}</span>
          </template>
        </el-table-column>
        <el-table-column label="库存重量(kg)" min-width="100px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.repertoryweight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="计划重量(kg)" min-width="100px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.planweight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="设备实测重量(kg)" min-width="150px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.actweight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="出库重量(kg)" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.operateweight }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.operateweight" placeholder="最多保留两位小数" type="number" :step="0.01" style="width:95%;padding:10px 0;" />
          </template>
        </el-table-column>
        <el-table-column :label="$t('formulationEvaluation.remark')" min-width="100px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.remark }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.remark"
:placeholder="$t('supplier.zf1')" type="textarea" :autosize="{ minRows: 1.3, maxRows: 4}" maxlength="32" style="width:95%;padding:10px 0;" />
          </template>
        </el-table-column>
        <el-table-column label="是否审核" min-width="100px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.ischarge == 1">{{$t('feedChart.yes')}}</span>
            <span v-else>{{$t('feedChart.no')}}</span>
          </template>
        </el-table-column>
        <el-table-column  :label="$t('errorAnalysis.cz')" align="center" width="80" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <el-button v-if="row.isUpdate && row.ischarge !== 1 && isRoleEdit" class="miniSuccess" icon="el-icon-edit-outline" @click="handleUpdate(row)" />
            <el-button v-if="row.isUpdateSave" :disabled="isokDisable" class="miniSuccess" icon="el-icon-folder-checked" @click="updateData(row)" />
            <el-button v-if="row.isUpdateSave" class="minCancel" icon="el-icon-close" @click="updateCancel(row)" />
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>=0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="getList" />
    </div>
  </div>

</template>

<script>
import { GetDataByName, GetDataByNames, checkButtons, PostDataByName, failproccess, ExecDataByConfig } from '@/api/common'
import Pagination from '@/components/Pagination'
import { MessageBox } from 'element-ui'
import Cookies from 'js-cookie'
import { parseTime, json2excel } from '@/utils/index.js'
export default {
  name: 'SystemConsumption',
  components: { Pagination },
  data() {
    return {

      livestockTypeList: [], // 牲畜类别
      feedNameList: [{ id: 0, name: '羊草' }, { id: 1, name: '小苏打' }], // 饲料名称
      isAuditList: [{ id: '1',
name:this.$t('supplier.yes')}, { id: '0',  
name:this.$t('supplier.no') }], // 是否审核
      requestParams: [
        { name: 'getFeedListEnable', offset: 0, pagecount: 0, parammaps: { pastureid: Cookies.get('pastureid') }},
        { name: 'getDictByName', offset: 0, pagecount: 0, params: ['牲畜父类'] }
      ],
      table: {
        getdataListParm: {
          name: 'getFeeduseList',
          page: 1,
          offset: 1,
          pagecount: parseInt(Cookies.get('pageCount')),
          returntype: 'Map',
          parammaps: {
            inputDatetime: '',
            pastureid: Cookies.get('pastureid'),
            startTime: '',
            stopTime: '',
            usetype: '系统用量',
            feedid: '',
            cowclassid: '',
            ischarge: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true
      },
      selectList: [],
      requestParam: {},
      download: {
        getdataListParm: {
          name: 'getFeeduseList',
          page: 1,
          offset: 1,
          pagecount: 0,
          returntype: 'Map',
          parammaps: {
            inputDatetime: '',
            pastureid: Cookies.get('pastureid'),
            startTime: '',
            stopTime: '',
            usetype: '系统用量',
            feedid: '',
            cowclassid: '',
            ischarge: ''
          }
        },
        list: []
      },
      isokDisable: false,
      isRoleEdit: [],
      rowStyle: { maxHeight: 30 + 'px', height: 30 + 'px' },
      cellStyle: { padding: 0 + 'px' }
    }
  },

  created() {
    this.getButtons()
    this.getDownList()
    this.getList()
  },

  methods: {
    getButtons() {
      const Edit = 'SystemConsumption'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    getDownList() {
      GetDataByNames(this.requestParams).then(response => {
        this.feedNameList = response.data.getFeedListEnable.list
        this.livestockTypeList = response.data.getDictByName.list
      })
    },
    handleBefore() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() - 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() - 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() + 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() + 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    getList() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            this.$set(response.data.list[i], 'Edit', false) // 编辑
            this.$set(response.data.list[i], 'NoEdit', true) // 不可编辑/输入
            this.$set(response.data.list[i], 'isUpdate', true) // 编辑操作
            this.$set(response.data.list[i], 'isUpdateSave', false) // 编辑保存
          }
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
        } else {
          this.table.list = []
        }
        this.table.total = response.data.total
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    form_search() {
      console.log('点击了查询')
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        this.table.getdataListParm.parammaps.startTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.table.getdataListParm.parammaps.inputDatetime = ''
        this.table.getdataListParm.parammaps.startTime = ''
        this.table.getdataListParm.parammaps.stopTime = ''
      }
      this.table.getdataListParm.offset = 1
      this.getList()
    },
    handleRefresh() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.inputDatetime = ''
      this.table.getdataListParm.parammaps.startTime = ''
      this.table.getdataListParm.parammaps.stopTime = ''
      this.table.getdataListParm.parammaps.feedid = ''
      this.table.getdataListParm.parammaps.cowclassid = ''
      this.table.getdataListParm.parammaps.ischarge = ''
      this.table.getdataListParm.offset = 1
      this.getList()
    },
    handleUpdate(row) {
      for (let i = 0; i < this.table.list.length; i++) {
        if (this.table.list[i].Edit == true) {
          this.$message({ type: 'error', message: this.$t('driver.messageNote'), duration: 2000 })
          return false
        }
      }
      // 编辑true,不可编辑false
      row.Edit = true
      row.NoEdit = false
      // 编辑false,编辑保存true
      row.isUpdate = false
      row.isUpdateSave = true
    },
    updateData(row) {
      console.log('点击了编辑保存', row)
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.requestParam.name = 'updateFeeduse'
      this.requestParam.parammaps = {}
      this.requestParam.parammaps.pastureid = row.pastureid
      this.requestParam.parammaps.id = row.id
      this.requestParam.parammaps.remark = row.remark
      this.requestParam.parammaps.operateweight = row.operateweight
      PostDataByName(this.requestParam).then(response => {
        console.log('新增保存发送参数', this.requestParam)
        if (response.msg !== 'fail') {
          this.$notify({ title: this.$t('common.succes'), message: this.$t('driver.saveSuccess'), type: 'success', duration: 2000 })
          this.getList()
        } else {
          this.$notify({ title: this.$t('driver.saveFail'), message: response.data, type: 'warning', duration: 2000 })
        }
      })
    },
    updateCancel(row) {
      console.log('点击了编辑取消')
      // 编辑false,不可编辑true
      row.Edit = false
      row.NoEdit = true
      // 编辑true,编辑保存false
      row.isUpdate = true
      row.isUpdateSave = false
      this.getList()
    },
    handleSelectionChange(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    handleExamine() {
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择需要审核的单据', duration: 2000 })
      } else {
        for (let i = 0; i < this.selectList.length; i++) {
          if (this.selectList[i].ischarge == 1) {
            this.$message({ type: 'error', message: '单据不可重复审核，请重新选择', duration: 2000 })
            return
          }
        }
        MessageBox.confirm('是否确认审核系统用量?', this.$t('message.msg111'), {
          confirmButtonText: this.$t('common.confirm'), cancelButtonText: this.$t('common.cancel'), type: 'warning'
        }).then(() => {
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.selectList }}
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = { 'name': 'insertFeedstorageUse', 'type': 'e', 'parammaps': {
            snowid: '@insertSpotList.snowid',
            pastureid: '@insertSpotList.pastureid',
            feedid: '@insertSpotList.feedid',
            fname: '@insertSpotList.fname',
            pcpde: '@insertSpotList.pcpde',
            operateweight: '@insertSpotList.operateweight',
            price: '@insertSpotList.price'
          }}
          this.requestParam.data[0].children[1] = { 'name': 'chargeFeedstorageuse', 'type': 'e', 'parammaps': {
            id: '@insertSpotList.id',
            pastureid: '@insertSpotList.pastureid',
            operateweight: '@insertSpotList.operateweight'
          }}
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('审核保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title:this.$t('message.msg37'), message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message:  this.$t('message.msg153'), type: 'success', duration: 2000 })
              this.getList()
            }
          })
        })
      }
    },
    handleExport() {
      console.log('点击了导出')
      this.download.getdataListParm.parammaps = this.table.getdataListParm.parammaps
      if (this.download.getdataListParm.parammaps.inputDatetime !== '' && this.download.getdataListParm.parammaps.inputDatetime !== null) {
        this.download.getdataListParm.parammaps.startTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.download.getdataListParm.parammaps.stopTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.download.getdataListParm.parammaps.inputDatetime = ''
        this.download.getdataListParm.parammaps.startTime = ''
        this.download.getdataListParm.parammaps.stopTime = ''
      }
      GetDataByName(this.download.getdataListParm).then(response => {
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            if (response.data.list[i].ischarge == 1) {
              response.data.list[i].ischarge = '是'
            } else {
              response.data.list[i].ischarge = '否'
            }
          }
          this.download.list = response.data.list
        } else {
          this.download.list = []
        }
        var excelDatas = [
          {
            tHeader: ['业务日期', '牲畜类别', '饲料名称', '库存重量（kg）', '计划重量（kg）', '设备实测重量（kg）', '出库重量（kg）', '备注', '是否审核'],
            filterVal: ['usedate', 'cowclass', 'feedname', 'repertoryweight', 'planweight', 'actweight', 'operateweight', 'remark', 'ischarge'],
            tableDatas: this.download.list,
            sheetName: 'Sheet1'
          }
        ]
        json2excel(excelDatas, '系统用量', true, 'xlsx')
      })
    }

  }
}
</script>
<style lang="scss" scoped>
  // .operation{margin-top:10px;}
  .search{margin-top:10px;}

 </style>
